import { Construct } from 'constructs';
import { TerraformResource } from 'cdktf';
import { TerraformMetaArguments } from 'cdktf';
/**
 *
 */
export interface BranchProtectionConfig extends TerraformMetaArguments {
    /**
     *
     */
    readonly branch: string;
    /**
     *
     */
    readonly enforceAdmins?: boolean;
    /**
     *
     */
    readonly repository: string;
    /**
     *
     */
    readonly requireSignedCommits?: boolean;
    /**
     * required_pull_request_reviews block.
     */
    readonly requiredPullRequestReviews?: BranchProtectionRequiredPullRequestReviews[];
    /**
     * required_status_checks block.
     */
    readonly requiredStatusChecks?: BranchProtectionRequiredStatusChecks[];
    /**
     * restrictions block.
     */
    readonly restrictions?: BranchProtectionRestrictions[];
}
/**
 *
 */
export interface BranchProtectionRequiredPullRequestReviews {
    /**
     *
     */
    readonly dismissStaleReviews?: boolean;
    /**
     *
     */
    readonly dismissalTeams?: string[];
    /**
     *
     */
    readonly dismissalUsers?: string[];
    /**
     *
     */
    readonly includeAdmins?: boolean;
    /**
     *
     */
    readonly requireCodeOwnerReviews?: boolean;
    /**
     *
     */
    readonly requiredApprovingReviewCount?: number;
}
/**
 *
 */
export interface BranchProtectionRequiredStatusChecks {
    /**
     *
     */
    readonly contexts?: string[];
    /**
     *
     */
    readonly includeAdmins?: boolean;
    /**
     *
     */
    readonly strict?: boolean;
}
/**
 *
 */
export interface BranchProtectionRestrictions {
    /**
     *
     */
    readonly apps?: string[];
    /**
     *
     */
    readonly teams?: string[];
    /**
     *
     */
    readonly users?: string[];
}
/**
 *
 */
export declare class BranchProtection extends TerraformResource {
    /**
     *
     */
    constructor(scope: Construct, id: string, config: BranchProtectionConfig);
    private _branch;
    /**
     *
     */
    get branch(): string;
    /**
     *
     */
    set branch(value: string);
    /**
     *
     */
    get branchInput(): string;
    private _enforceAdmins?;
    /**
     *
     */
    get enforceAdmins(): boolean;
    /**
     *
     */
    set enforceAdmins(value: boolean);
    /**
     *
     */
    resetEnforceAdmins(): void;
    /**
     *
     */
    get enforceAdminsInput(): boolean | undefined;
    /**
     *
     */
    get etag(): string;
    /**
     *
     */
    get id(): string;
    private _repository;
    /**
     *
     */
    get repository(): string;
    /**
     *
     */
    set repository(value: string);
    /**
     *
     */
    get repositoryInput(): string;
    private _requireSignedCommits?;
    /**
     *
     */
    get requireSignedCommits(): boolean;
    /**
     *
     */
    set requireSignedCommits(value: boolean);
    /**
     *
     */
    resetRequireSignedCommits(): void;
    /**
     *
     */
    get requireSignedCommitsInput(): boolean | undefined;
    private _requiredPullRequestReviews?;
    /**
     *
     */
    get requiredPullRequestReviews(): BranchProtectionRequiredPullRequestReviews[];
    /**
     *
     */
    set requiredPullRequestReviews(value: BranchProtectionRequiredPullRequestReviews[]);
    /**
     *
     */
    resetRequiredPullRequestReviews(): void;
    /**
     *
     */
    get requiredPullRequestReviewsInput(): BranchProtectionRequiredPullRequestReviews[] | undefined;
    private _requiredStatusChecks?;
    /**
     *
     */
    get requiredStatusChecks(): BranchProtectionRequiredStatusChecks[];
    /**
     *
     */
    set requiredStatusChecks(value: BranchProtectionRequiredStatusChecks[]);
    /**
     *
     */
    resetRequiredStatusChecks(): void;
    /**
     *
     */
    get requiredStatusChecksInput(): BranchProtectionRequiredStatusChecks[] | undefined;
    private _restrictions?;
    /**
     *
     */
    get restrictions(): BranchProtectionRestrictions[];
    /**
     *
     */
    set restrictions(value: BranchProtectionRestrictions[]);
    /**
     *
     */
    resetRestrictions(): void;
    /**
     *
     */
    get restrictionsInput(): BranchProtectionRestrictions[] | undefined;
    /**
     *
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
