import { Construct } from 'constructs';
import { TerraformResource } from 'cdktf';
import { TerraformMetaArguments } from 'cdktf';
/**
 *
 */
export interface BranchConfig extends TerraformMetaArguments {
    /**
     *
     */
    readonly branch: string;
    /**
     *
     */
    readonly repository: string;
    /**
     *
     */
    readonly sourceBranch?: string;
    /**
     *
     */
    readonly sourceSha?: string;
}
/**
 *
 */
export declare class Branch extends TerraformResource {
    /**
     *
     */
    constructor(scope: Construct, id: string, config: BranchConfig);
    private _branch;
    /**
     *
     */
    get branch(): string;
    /**
     *
     */
    set branch(value: string);
    /**
     *
     */
    get branchInput(): string;
    /**
     *
     */
    get etag(): string;
    /**
     *
     */
    get id(): string;
    /**
     *
     */
    get ref(): string;
    private _repository;
    /**
     *
     */
    get repository(): string;
    /**
     *
     */
    set repository(value: string);
    /**
     *
     */
    get repositoryInput(): string;
    /**
     *
     */
    get sha(): string;
    private _sourceBranch?;
    /**
     *
     */
    get sourceBranch(): string;
    /**
     *
     */
    set sourceBranch(value: string);
    /**
     *
     */
    resetSourceBranch(): void;
    /**
     *
     */
    get sourceBranchInput(): string | undefined;
    private _sourceSha?;
    /**
     *
     */
    get sourceSha(): string;
    /**
     *
     */
    set sourceSha(value: string);
    /**
     *
     */
    resetSourceSha(): void;
    /**
     *
     */
    get sourceShaInput(): string | undefined;
    /**
     *
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
