import { Construct } from 'constructs';
import { TerraformResource } from 'cdktf';
import { TerraformMetaArguments } from 'cdktf';
/**
 *
 */
export interface TeamSyncGroupMappingConfig extends TerraformMetaArguments {
    /**
     *
     */
    readonly teamSlug: string;
    /**
     * group block.
     */
    readonly group?: TeamSyncGroupMappingGroup[];
}
/**
 *
 */
export interface TeamSyncGroupMappingGroup {
    /**
     *
     */
    readonly groupDescription: string;
    /**
     *
     */
    readonly groupId: string;
    /**
     *
     */
    readonly groupName: string;
}
/**
 *
 */
export declare class TeamSyncGroupMapping extends TerraformResource {
    /**
     *
     */
    constructor(scope: Construct, id: string, config: TeamSyncGroupMappingConfig);
    /**
     *
     */
    get etag(): string;
    /**
     *
     */
    get id(): string;
    private _teamSlug;
    /**
     *
     */
    get teamSlug(): string;
    /**
     *
     */
    set teamSlug(value: string);
    /**
     *
     */
    get teamSlugInput(): string;
    private _group?;
    /**
     *
     */
    get group(): TeamSyncGroupMappingGroup[];
    /**
     *
     */
    set group(value: TeamSyncGroupMappingGroup[]);
    /**
     *
     */
    resetGroup(): void;
    /**
     *
     */
    get groupInput(): TeamSyncGroupMappingGroup[] | undefined;
    /**
     *
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
